#! perl
use strict;
use CGI qw/:standard/;

use Gesamt;

my $Text = param('Text'); #
my $Titel = param('Titel');#

Analysieren( $Titel ,$Text );

sub Analysieren{
	my ($Titel, $Text) = @_; # Der gesamte Text als String
	my @Woerter; #Array in dem alle Wrter stehen
	my %Datensatze = (); #Die Datenstze, in Form von AWM
	my $IDWort; # Das Aktuelle Wort in ASCII und klein
	
	if($Titel eq ""){
		DateiFehlt();
		return;		
	}

	
	###########Erstmal die einzelnen Wrter raussuchen###################
	$Text =~ s/-\s*\n\s*//g; #Getrenne Wrter in verschiedenen Zeilen zusammenfassen
	
	$Text =~ s/\n/ /g; #Zeilenumbrche entfernen;
	$Text =~ s/[<>="+~#']/ /g; #Sonderzeichen entfernen

	$Text =~ s/\s\s/ /g; #Doppelten Whitespace entfernen

	
	$Text =~ s/\./\.\n/g; #Nach Punkten trennen
	$Text =~ s/\!/\!\n/g; #Nach Ausrufezeichen trennen
	$Text =~ s/\?/\?\n/g; #Nach Fragezeichen trennen
	$Text =~ s/:/:\n/g; #Nach Fragezeichen trennen
	
	do{
	$Text =~ s/\n /\n/g; #Leerzeichen am Zeilenanfang entfernen.
	} while ($Text =~ /\n /); #...solange Leerzeichen am Zeilenanfang da sind...

	$Text =~ s/,/ ,/g; #Vor jedes Komma ein Leerzeichen
	$Text =~ s/;/ <,,>/g; #Vor jedes Semikolon
	$Text =~ s/\./ \./g; #Vor jeden Punkt ein Leerzeichen
	$Text =~ s/!/ !/g; #Vor jedes Ausrufezeichen ein Leerzeichen
	$Text =~ s/\?/ \?/g; #Vor jedes Fragezeichen ein Leerzeichen
	$Text =~ s/\(/\( /g;
	$Text =~ s/\)/ \)/g;
	$Text =~ s/  / /g;
	
	
	@Woerter = split ("[\n ]", $Text); # Zerschneiden des Textes in die einzelnen Wrter 
		
	foreach my $Wort (@Woerter) #Jedes Wort
	{

		$IDWort = german2ascii(lc($Wort)); #Grundform finden		

		$Datensatze{$IDWort}->{HowMany} += 1; #Anzahl um 1 erhhen
		
		if (!($Wort =~ /^[A-Z]/) or ($Datensatze{$IDWort}->{HowMany} == 1)) # Orginalform hinschreiben, wenn klein oder wenn's das erste Mal verwendet wird. <- Sorgt dafr, dass Wrter, die hufiger vorkommen und nur nach Punkten grogeschrieben werden als klein in der Orginalform vorkommen.
		{
		$Datensatze{$IDWort}->{OWort} = $Wort; #Orginalwort
		}
		
	}
	###########Dann die Wrter davor und dannach rausfinden###############
	my @Saetze; #Vorstufe (Stze als Array)
	my @TextStruk; # Der Text als Array aus Stzen, welche Arrays aus Wrtern sind.
	
	$Text = lc( german2ascii ($Text)); #Um's einfacher zu haben (Alles in klein und Ascii)
	
	@Saetze = split("\n", $Text); #In Stze gesplittet
	

	
	my $SN = 0;
	while ($SN < @Saetze)
	{
		my @test =split(" ", $Saetze[$SN]);
		$TextStruk[$SN] = \@test;
	
		#print $TextStruk[$SN][0] . "\n";
		
			$SN += 1;
	}
		
		
	foreach my $AktSatz ( @TextStruk )
	{
		my $AktWort = 0;
		while ($AktWort < @$AktSatz)
		{
			if ($AktWort != 0)
			{
				$Datensatze{@$AktSatz[$AktWort]}->{'davor'}->{@$AktSatz[$AktWort - 1]} += 1;
				#print "dav = @$AktSatz[$AktWort]\n";
			}
			
			if ($AktWort < @$AktSatz - 1)
			{
				$Datensatze{@$AktSatz[$AktWort]}->{'danach'}->{@$AktSatz[$AktWort + 1]} += 1;
				#print "dan = @$AktSatz[$AktWort]\n";
			}
			
	

			$AktWort++;
		}
		
	}		
		
#######################################	
my $Datei;
use Data::Dumper;
$Data::Dumper::Purity = 1;
$Data::Dumper::Varname = "";
$Datei = Dumper(%Datensatze);

	$Datei =~ s/\$[0-9]* =//g; #Nummern vor den Variablen entfernen
	$Datei =~ s/\'\;\n/' =>/g; #<-siehe da
	$Datei =~ s/\;/,/g; #<-siehe da
	$Datei =~ s/://g; #<-siehe da
	$Datei =~ s/\s//g; #Whitespace entfernen
#print $Datei;
####################################### //Speichern
print_text( "$Titel.aly", $Datei); 
#######################################	
Ausgabe($Titel);
	
}


sub print_text {
my ($outfile,$text) = (@_); # modifiziert

open(OUT, ">$outfile"); # neu

	print OUT "$text"; # modifiziert

close(OUT); # neu
return 1;
};


sub german2ascii { #Entfernt deutsche Sonderzeichen
	my $w = shift;
	$w =~ s//ae/g;
	$w =~ s//oe/g;
	$w =~ s//ue/g;
	$w =~ s//ae/g;
	$w =~ s//oe/g;
	$w =~ s//ue/g;
	$w =~ s//ss/g;
	return $w;
};

sub Ausgabe{
	my ($Titel) = @_;
		print header,
		start_html("Fertig!"),
			style({-type=>"text/css"}, Stil()),
			ZurueckZurHauptseite(),
			p({-align=>'center'}, a({-href=>"Show.pl?mode=alpha&what=all&Titel=$Titel"},"Alle Wrter - nach Alphabet geordnet anzeigen")),
			p({-align=>'center'}, a({-href=>"Show.pl?mode=quanti&what=all&Titel=$Titel"},"Alle Wrter - nach Anzahl geordnet anzeigen")),
		end_html;
}